Package io.vertx.rxjava3.core.eventbus

## Class MessageProducer<T>

- java.lang.Object
- - io.vertx.rxjava3.core.eventbus.MessageProducer<T>

- All Implemented Interfaces:
    `io.vertx.lang.rx.RxDelegate`

      public class MessageProducer<T>
      extends Object
      implements io.vertx.lang.rx.RxDelegate

  Represents a stream of message that can be written to.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static io.vertx.lang.rx.TypeArg<MessageProducer>` | `__TYPE_ARG` |
    `io.vertx.lang.rx.TypeArg<T>` | `__typeArg_0` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `MessageProducer​(MessageProducer delegate)` |
    `MessageProducer​(Object delegate, io.vertx.lang.rx.TypeArg<T> typeArg_0)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `String` | `address()` |
    `Completable` | `close()` | Closes the producer, this method should be called when the message producer is not used anymore.
    `MessageProducer<T>` | `deliveryOptions​(DeliveryOptions options)` | Update the delivery options of this producer.
    `boolean` | `equals​(Object o)` |
    `MessageProducer` | `getDelegate()` |
    `int` | `hashCode()` |
    `static <T> MessageProducer<T>` | `newInstance​(MessageProducer arg)` |
    `static <T> MessageProducer<T>` | `newInstance​(MessageProducer arg, io.vertx.lang.rx.TypeArg<T> __typeArg_T)` |
    `Completable` | `rxClose()` | Closes the producer, this method should be called when the message producer is not used anymore.
    `Completable` | `rxWrite​(T body)` | Write a message to the event-bus, either sending or publishing.
    `String` | `toString()` |
    `Completable` | `write​(T body)` | Write a message to the event-bus, either sending or publishing.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<MessageProducer> __TYPE_ARG

    - #### __typeArg_0

          public final io.vertx.lang.rx.TypeArg<T> __typeArg_0

  - ### Constructor Detail

    - #### MessageProducer

          public MessageProducer​(MessageProducer delegate)

    - #### MessageProducer

          public MessageProducer​(Object delegate,
                                 io.vertx.lang.rx.TypeArg<T> typeArg_0)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### getDelegate

          public MessageProducer getDelegate()

      Specified by:
        `getDelegate` in interface `io.vertx.lang.rx.RxDelegate`

    - #### deliveryOptions

          public MessageProducer<T> deliveryOptions​(DeliveryOptions options)

      Update the delivery options of this producer.
      Parameters:
        `options` - the new options
      Returns:
        this producer object

    - #### address

          public String address()

      Returns:
        The address to which the producer produces messages.

    - #### write

          public Completable write​(T body)

      Write a message to the event-bus, either sending or publishing. The returned completion depends on the producer type:
      - send or request: the future is completed successfully if the message has been written; otherwise, the future is failed
      - publish: the future is failed if there is no recipient; otherwise, the future is completed successfully
      In any case, a successfully completed is not a delivery guarantee.
      Parameters:
        `body` - the message body
      Returns:

    - #### rxWrite

          public Completable rxWrite​(T body)

      Write a message to the event-bus, either sending or publishing. The returned completion depends on the producer type:
      - send or request: the future is completed successfully if the message has been written; otherwise, the future is failed
      - publish: the future is failed if there is no recipient; otherwise, the future is completed successfully
      In any case, a successfully completed is not a delivery guarantee.
      Parameters:
        `body` - the message body
      Returns:

    - #### close

          public Completable close()

      Closes the producer, this method should be called when the message producer is not used anymore.
      Returns:
        a future completed with the result

    - #### rxClose

          public Completable rxClose()

      Closes the producer, this method should be called when the message producer is not used anymore.
      Returns:
        a future completed with the result

    - #### newInstance

          public static <T> MessageProducer<T> newInstance​(MessageProducer arg)

    - #### newInstance

          public static <T> MessageProducer<T> newInstance​(MessageProducer arg,
                                                           io.vertx.lang.rx.TypeArg<T> __typeArg_T)